/* xpcom function to transform strings. */

/* Our conversion object. */
function create_ctr() {
    this.transStr = get_trans_str();
    this.trans = trans;
    this.add_pair = add_pair;
    this.add_obj = add_obj;
    this.stest = stest;
    return this;
}

/* Add a key, val pair to conversion table. */
function add_pair(first, second) {
    this.transStr.tableInsert(first, second);
}

/* Add all the attribute of an object to conversion table. */
/* Remember the js objects are also hashtables. */
function add_obj(obj) {
    var emptyobj = {};
    for (var i in obj) {
	if (!(i in emptyobj)) {
	    this.transStr.tableInsert(i, obj[i]);
	}
    }
}

/* Actual transform input string. */
function trans(instr) {
    try {
	return this.transStr.trans(instr);
    }catch(e){
	// myalert(e + instr.length);
	return instr;
    }
}

/* Fetch the transstring interface from xpcom. */
function get_trans_str() {
    var transStr = null;
    try {
	transStr = Components.classes["@hashao/transstring"];
	transStr = transStr.createInstance(Components.interfaces.iTransString);
    } catch(e) {
	//myalert(e);
	return null;
    }
    //myalert(transStr);
    return transStr;
}

/* Initialize, if we can load transstring xpcom, then create both s->t */
/* and t->s conversion  objects. */
var hasctrans = false;
var cs2t = new create_ctr();
if (cs2t.transStr != null) {
    hasctrans = true;
    ct2s = new create_ctr();
    cs2t.add_obj(s_2_t);
    ct2s.add_obj(t_2_s);
    ct2s.add_obj(t_2_s_phrase);
}

/********************************************************************/
/********************************************************************/
function stest() {
    this.add_pair('a', 'A');
    myalert(this.trans('an apple eater.'));
}

